/***************************************************************************************************/
/*script in Sql, generate by SdmCreateScript 2020(by Qihang Feng, QF255001@TERADATA.COM)     */
/*VERSION 01.10 revised on 2020-08-25                                                              */
/*Brilliance stems from wisdoms.                                                                   */
/*************Head Section**************************************************************************/
/*Script Use: Periodically load data to :t01_crm_opportunity(CRM销售机会)             */
/*Create Date:2024-04-19 15:27:22                                                                  */
/*SDM Developed By: dev                                                                            */
/*SDM Developed Date: 2024-04-19                                                                   */
/*SDM Checked By: dev                                                                              */
/*SDM Checked Date: 2024-04-19                                                                     */
/*Script Developed By: dev                                                                         */
/*Script Checked By: dev                                                                           */
/*Source table 1: p10_sa.s98_s_crm_opp                                                             */
/*Job Type: Inbound transform (Tier 1 to Tier 2)                                                   */
/*Target Table:t01_crm_opportunity                                                                 */
/*ETL Job Name:t01_crm_opportunity                                                                 */
/*ETL Frequency:Daily                                                                              */
/*ETL Policy:F5                                                                                    */
/********************************************************************************************/
/*******Main Section**************************************************************************/
\set ON_ERROR_STOP on
\set AUTOCOMMIT on
\timing on



/*创建临时表加载当前数据                                                                           */
CREATE TEMPORARY TABLE t01_crm_opportunity_agi_CUR_I 
 ( LIKE :PDMDB.t01_crm_opportunity)
ON COMMIT PRESERVE ROWS;



/*创建临时表加载不同数据                                                                           */
CREATE TEMPORARY TABLE t01_crm_opportunity_agi_INS 
( LIKE :PDMDB.t01_crm_opportunity)
ON COMMIT PRESERVE ROWS;

/*创建临时表加载当前有效数据                                                                           */
CREATE TEMPORARY TABLE t01_crm_opportunity_agi_CUR 
( LIKE :PDMDB.t01_crm_opportunity)
ON COMMIT PRESERVE ROWS;

/*创建临时表加载缺失数据                                                                           */
CREATE TEMPORARY TABLE t01_crm_opportunity_agi_CUR_D 
( LIKE :PDMDB.t01_crm_opportunity)
ON COMMIT PRESERVE ROWS;


/*****************************************************************************************************/
/* GROUP 1:Source Table:s98_s_crm_opp*****************************************************************/
/*****************************************************************************************************/
INSERT INTO t01_crm_opportunity_agi_CUR_I (
            tek_opportunity_id                      /*泰克机会编号*/
           ,opportunity_name                        /*机会名称*/
           ,tektronix_apname                        /*tek_tektronixapname*/
           ,estimated_close_time                    /*预期关闭时间*/
           ,parent_account_name                     /*父账号名称*/
           ,parent_contact_name                     /*父联系人名称*/
           ,product_name                            /*产品名称*/
           ,product_class                           /*产品类别*/
           ,currency_name                           /*交易币种*/
           ,uint_price                              /*单价*/
           ,discount_percent                        /*折扣率*/
           ,discount_amount_base                    /*基础折扣金额*/
           ,base_amount                             /*基础金额*/
           ,total_amount                            /*总金额*/
           ,sales_funnel_stage                      /*销售漏斗层级*/
           ,sales_funnel_stage_id                   /*销售漏斗层级编号*/
           ,status                                  /*状况*/
           ,state                                   /*状态*/
           ,region                                  /*区域*/
           ,acount_manager                          /*账号经理*/
           ,territory_id                            /*领域编号*/
           ,forecast_opp_ind                        /*预期机会标志*/
           ,risk_ind                                /*风险标志*/
           ,opportunity_age                         /*机会年份*/
           ,create_time                             /*创建时间*/
           ,create_person                           /*创建人*/
           ,pipline_last_update                     /*pipline最后更新时间*/
           ,status_last_update                      /*状况最后更新时间*/
           ,channel_id                              /*渠道编号*/
           ,purchase_method                         /*采购方式*/
           ,campaign_name                           /*活动名称*/
           ,web_medium                              /*网络媒介*/
           ,web_source                              /*网络来源*/
           ,customer_app                            /*客户应用*/
           ,vertical_segment                        /*垂直领域*/
           ,competitive_status                      /*竞争状态*/
           ,important_opportunity_ind               /*重要机会标志*/
           ,application_name                        /*应用名称*/
           ,opp_industry                            /*行业（opp)*/
           ,tag_list                                /*标签列表*/
           ,discount_amount                         /*折扣金额*/
           ,area_id                                 /*地区编号*/
           ,branch_id                               /*分支编号*/
           ,extension_id                            /*扩展编号*/
           ,legal_company_name                      /*法定公司名称*/
           ,account_number                          /*账号编号*/
           ,marketing_program_type                  /*市场项目类型*/
           ,lead_number                             /*线索编号*/
           ,crm_contact_number                      /*联系人编号*/
           ,Scd_Start_Dt                            /*开始时间*/
           ,Scd_End_Dt                              /*结束时间*/
           ,Etl_Batch_No                            /*作业批次号*/
           ,Etl_First_Dt                            /*最初入库时间*/
           ,Etl_Job                                 /*作业名称*/
           ,Etl_Proc_Dt                             /*本次入库时间*/
           ,Etl_Tx_Dt                               /*作业运行时间*/
           ,Src_Sysname                             /*来源系统*/
           ,Src_Table                               /*来源表*/
        )
SELECT
         COALESCE(TRIM(CAST(p0.tek_opportunitynumber AS varchar(20))),'')        /*tek_opportunity_id*/
        ,COALESCE(TRIM(CAST(p0.name AS varchar(100))),'')          /*opportunity_name*/
        ,COALESCE(TRIM(p0.tek_tektronixapname),'')                 /*tektronix_apname*/
        ,COALESCE(TO_TIMESTAMP(CAST(p0.estimatedclosedate AS VARCHAR(19)),'YYYY-MM-DD HH24:mi:ss'),TO_TIMESTAMP(:NULLDATE,'YYYYMMDD'))        /*estimated_close_time*/
        ,COALESCE(TRIM(CAST(p0.parentaccountidname AS varchar(200))),'')        /*parent_account_name*/
        ,COALESCE(TRIM(CAST(p0.parentcontactidname AS varchar(20))),'')        /*parent_contact_name*/
        ,COALESCE(TRIM(CAST(p0.tek_productidname AS varchar(50))),'')        /*product_name*/
        ,COALESCE(TRIM(CAST(p0.tek_productfamilyidname AS varchar(50))),'')        /*product_class*/
        ,COALESCE(TRIM(CAST(p0.transactioncurrencyidname AS varchar(20))),'')        /*currency_name*/
        ,COALESCE(CAST(p0.tek_unitpricetotal_base AS int),0)        /*uint_price*/
        ,COALESCE(CAST(p0.tek_totaldiscountpercent AS numeric(12,4)),0)        /*discount_percent*/
        ,COALESCE(CAST(p0.totaldiscountamount_base AS numeric(16,4)),0)        /*discount_amount_base*/
        ,COALESCE(CAST(p0.estimatedvalue_base AS numeric(16,4)),0)        /*base_amount*/
        ,COALESCE(CAST(p0.totalamount AS numeric(16,4)),0)         /*total_amount*/
        ,COALESCE(TRIM(CAST(p0.tek_salesfunnelstagename AS varchar(50))),'')        /*sales_funnel_stage*/
        ,COALESCE(CAST(p0.tek_funnelstagenumber AS int),0)         /*sales_funnel_stage_id*/
        ,COALESCE(TRIM(CAST(p0.statuscodename AS varchar(50))),'')        /*status*/
        ,COALESCE(TRIM(CAST(p0.statecodename AS varchar(10))),'')        /*state*/
        ,COALESCE(TRIM(CAST(p0.tek_regionidname AS varchar(10))),'')        /*region*/
        ,COALESCE(TRIM(CAST(p0.tek_accountmanageridname AS varchar(20))),'')        /*acount_manager*/
        ,COALESCE(TRIM(CAST(p0.tek_oppterritoryidname AS varchar(50))),'')        /*territory_id*/
        ,COALESCE(TRIM(CAST(p0.tek_opp_includeinforecastname AS varchar(10))),'')        /*forecast_opp_ind*/
        ,COALESCE(TRIM(CAST(p0.tek_isriskname AS varchar(10))),'')        /*risk_ind*/
        ,COALESCE(CAST(p0.tek_opportunityage AS int),0)            /*opportunity_age*/
        ,COALESCE(TO_TIMESTAMP(CAST(p0.createdon AS VARCHAR(19)),'YYYY-MM-DD HH24:mi:ss'),TO_TIMESTAMP(:NULLDATE,'YYYYMMDD'))        /*create_time*/
        ,COALESCE(TRIM(CAST(p0.createdbyname AS varchar(50))),'')        /*create_person*/
        ,COALESCE(TO_TIMESTAMP(CAST(p0.tek_piplinelastupdatedon AS VARCHAR(19)),'YYYY-MM-DD HH24:mi:ss'),TO_TIMESTAMP(:NULLDATE,'YYYYMMDD'))        /*pipline_last_update*/
        ,COALESCE(TO_TIMESTAMP(CAST(p0.tek_laststatusdate AS VARCHAR(19)),'YYYY-MM-DD HH24:mi:ss'),TO_TIMESTAMP(:NULLDATE,'YYYYMMDD'))        /*status_last_update*/
        ,COALESCE(TRIM(CAST(p0.tek_channelidname AS varchar(50))),'')        /*channel_id*/
        ,COALESCE(TRIM(CAST(p0.tek_purchasemethodname AS varchar(50))),'')        /*purchase_method*/
        ,COALESCE(TRIM(CAST(p0.campaignidname AS varchar(50))),'')        /*campaign_name*/
        ,COALESCE(TRIM(CAST(p0.tek_webvisitormedium AS varchar(50))),'')        /*web_medium*/
        ,COALESCE(TRIM(CAST(p0.tek_webvisitorsource AS varchar(100))),'')        /*web_source*/
        ,COALESCE(TRIM(CAST(p0.tek_customerapplication AS varchar(50))),'')        /*customer_app*/
        ,COALESCE(TRIM(CAST(p0.tek_vertical_segmentname AS varchar(50))),'')        /*vertical_segment*/
        ,COALESCE(TRIM(CAST(p0.tek_competitivestatusname AS varchar(50))),'')        /*competitive_status*/
        ,COALESCE(TRIM(CAST(p0.tek_importantopportunityname AS varchar(10))),'')        /*important_opportunity_ind*/
        ,COALESCE(TRIM(CAST(p0.tek_applicationidname AS varchar(100))),'')        /*application_name*/
        ,COALESCE(TRIM(CAST(p0.tek_industryidname AS varchar(100))),'')        /*opp_industry*/
        ,COALESCE(TRIM(CAST(p0.tek_taglist AS varchar(100))),'')        /*tag_list*/
        ,COALESCE(CAST(p0.discountamount AS numeric(16,4)),0)        /*discount_amount*/
        ,COALESCE(TRIM(CAST(p0.tek_terr_areaidname AS varchar(100))),'')        /*area_id*/
        ,COALESCE(TRIM(CAST(p0.tek_terr_branchidname AS varchar(100))),'')        /*branch_id*/
        ,COALESCE(TRIM(CAST(p0.tek_extension AS varchar(100))),'')        /*extension_id*/
        ,COALESCE(TRIM(CAST(p0.tek_companynamelegal AS varchar(200))),'')        /*legal_company_name*/
        ,COALESCE(TRIM(CAST(p0.accountnumber AS varchar(100))),'')        /*account_number*/
        ,COALESCE(TRIM(CAST(p0.tek_marketing_program_type_idname AS varchar(100))),'')        /*marketing_program_type*/
        ,COALESCE(TRIM(CAST(p0.tek_leadnumber AS varchar(20))),'')        /*lead_number*/
        ,COALESCE(TRIM(CAST(p0.tek_contactnumber AS varchar(20))),'')        /*crm_contact_number*/
        ,COALESCE(p0.Scd_Start_Dt,TO_DATE(:NULLDATE,'YYYYMMDD'))        /*Scd_Start_Dt*/
        ,COALESCE(p0.Scd_End_Dt,TO_DATE(:NULLDATE,'YYYYMMDD'))        /*Scd_End_Dt*/
        ,0                                                         /*Etl_Batch_No*/
        ,TO_DATE(:TXDATE,'YYYYMMDD')                               /*Etl_First_Dt*/
        ,:ETLJOB                                                   /*Etl_Job*/
        ,current_timestamp(0)                                      /*Etl_Proc_Dt*/
        ,TO_DATE(:TXDATE,'YYYYMMDD')                               /*Etl_Tx_Dt*/
        ,Substr('s98_s_crm_opp',1,3)                               /*Src_Sysname*/
        ,'s98_s_crm_opp'                                           /*Src_Table*/
        
FROM p10_sa.s98_s_crm_opp  p0
;



/*避免同一天多次运行造成数据重复                                                                   */

DELETE FROM :PDMDB.t01_crm_opportunity
WHERE ETL_JOB=:ETLJOB 
AND scd_End_Dt=TO_DATE(:MAXDATE,'YYYYMMDD')
AND scd_Start_Dt=TO_DATE(:TXDATE,'YYYYMMDD');
UPDATE :PDMDB.t01_crm_opportunity
SET scd_End_Dt=TO_DATE(:MAXDATE,'YYYYMMDD')
WHERE ETL_JOB=:ETLJOB
AND scd_End_Dt=TO_DATE(:TXDATE,'YYYYMMDD'); 

/*往临时表插入当前数据。                                                               */
INSERT INTO t01_crm_opportunity_agi_CUR(
     tek_opportunitynumber                                     /*tek_opportunitynumber*/
    ,tek_unitpricetotal_base                                   /*tek_unitpricetotal_base*/
    ,tek_totaldiscountpercent                                  /*tek_totaldiscountpercent*/
    ,totaldiscountamount_base                                  /*totaldiscountamount_base*/
    ,estimatedvalue_base                                       /*estimatedvalue_base*/
    ,totalamount                                               /*totalamount*/
    ,tek_salesfunnelstagename                                  /*tek_salesfunnelstagename*/
    ,tek_funnelstagenumber                                     /*tek_funnelstagenumber*/
    ,statuscodename                                            /*statuscodename*/
    ,statecodename                                             /*statecodename*/
    ,tek_regionidname                                          /*tek_regionidname*/
    ,name                                                      /*name*/
    ,tek_accountmanageridname                                  /*tek_accountmanageridname*/
    ,tek_oppterritoryidname                                    /*tek_oppterritoryidname*/
    ,tek_opp_includeinforecastname                             /*tek_opp_includeinforecastname*/
    ,tek_isriskname                                            /*tek_isriskname*/
    ,tek_opportunityage                                        /*tek_opportunityage*/
    ,createdon                                                 /*createdon*/
    ,createdbyname                                             /*createdbyname*/
    ,tek_piplinelastupdatedon                                  /*tek_piplinelastupdatedon*/
    ,tek_laststatusdate                                        /*tek_laststatusdate*/
    ,tek_channelidname                                         /*tek_channelidname*/
    ,tek_tektronixapname                                       /*tek_tektronixapname*/
    ,tek_purchasemethodname                                    /*tek_purchasemethodname*/
    ,campaignidname                                            /*campaignidname*/
    ,tek_webvisitormedium                                      /*tek_webvisitormedium*/
    ,tek_webvisitorsource                                      /*tek_webvisitorsource*/
    ,tek_customerapplication                                   /*tek_customerapplication*/
    ,tek_vertical_segmentname                                  /*tek_vertical_segmentname*/
    ,tek_competitivestatusname                                 /*tek_competitivestatusname*/
    ,tek_importantopportunityname                              /*tek_importantopportunityname*/
    ,tek_applicationidname                                     /*tek_applicationidname*/
    ,tek_industryidname                                        /*tek_industryidname*/
    ,estimatedclosedate                                        /*estimatedclosedate*/
    ,tek_taglist                                               /*tek_taglist*/
    ,discountamount                                            /*discountamount*/
    ,tek_terr_areaidname                                       /*tek_terr_areaidname*/
    ,tek_terr_branchidname                                     /*tek_terr_branchidname*/
    ,tek_extension                                             /*tek_extension*/
    ,tek_companynamelegal                                      /*tek_companynamelegal*/
    ,accountnumber                                             /*accountnumber*/
    ,tek_marketing_program_type_idname                         /*tek_marketing_program_type_idname*/
    ,tek_leadnumber                                            /*tek_leadnumber*/
    ,tek_contactnumber                                         /*tek_contactnumber*/
    ,parentaccountidname                                       /*parentaccountidname*/
    ,Scd_Start_Dt                                              /*开始时间*/
    ,Scd_End_Dt                                                /*结束时间*/
    ,Etl_Batch_No                                              /*作业批次号*/
    ,Etl_First_Dt                                              /*最初入库时间*/
    ,Etl_Job                                                   /*作业名称*/
    ,Etl_Proc_Dt                                               /*本次入库时间*/
    ,Etl_Tx_Dt                                                 /*作业运行时间*/
    ,Src_Sysname                                               /*来源系统*/
    ,Src_Table                                                 /*来源表*/
    ,parentcontactidname                                       /*parentcontactidname*/
    ,tek_productidname                                         /*tek_productidname*/
    ,tek_productfamilyidname                                   /*tek_productfamilyidname*/
    ,transactioncurrencyidname                                 /*transactioncurrencyidname*/
    )
SELECT      
     P1.tek_opportunitynumber                                     /*tek_opportunitynumber*/
    ,P1.tek_unitpricetotal_base                                   /*tek_unitpricetotal_base*/
    ,P1.tek_totaldiscountpercent                                  /*tek_totaldiscountpercent*/
    ,P1.totaldiscountamount_base                                  /*totaldiscountamount_base*/
    ,P1.estimatedvalue_base                                       /*estimatedvalue_base*/
    ,P1.totalamount                                               /*totalamount*/
    ,P1.tek_salesfunnelstagename                                  /*tek_salesfunnelstagename*/
    ,P1.tek_funnelstagenumber                                     /*tek_funnelstagenumber*/
    ,P1.statuscodename                                            /*statuscodename*/
    ,P1.statecodename                                             /*statecodename*/
    ,P1.tek_regionidname                                          /*tek_regionidname*/
    ,P1.name                                                      /*name*/
    ,P1.tek_accountmanageridname                                  /*tek_accountmanageridname*/
    ,P1.tek_oppterritoryidname                                    /*tek_oppterritoryidname*/
    ,P1.tek_opp_includeinforecastname                             /*tek_opp_includeinforecastname*/
    ,P1.tek_isriskname                                            /*tek_isriskname*/
    ,P1.tek_opportunityage                                        /*tek_opportunityage*/
    ,P1.createdon                                                 /*createdon*/
    ,P1.createdbyname                                             /*createdbyname*/
    ,P1.tek_piplinelastupdatedon                                  /*tek_piplinelastupdatedon*/
    ,P1.tek_laststatusdate                                        /*tek_laststatusdate*/
    ,P1.tek_channelidname                                         /*tek_channelidname*/
    ,P1.tek_tektronixapname                                       /*tek_tektronixapname*/
    ,P1.tek_purchasemethodname                                    /*tek_purchasemethodname*/
    ,P1.campaignidname                                            /*campaignidname*/
    ,P1.tek_webvisitormedium                                      /*tek_webvisitormedium*/
    ,P1.tek_webvisitorsource                                      /*tek_webvisitorsource*/
    ,P1.tek_customerapplication                                   /*tek_customerapplication*/
    ,P1.tek_vertical_segmentname                                  /*tek_vertical_segmentname*/
    ,P1.tek_competitivestatusname                                 /*tek_competitivestatusname*/
    ,P1.tek_importantopportunityname                              /*tek_importantopportunityname*/
    ,P1.tek_applicationidname                                     /*tek_applicationidname*/
    ,P1.tek_industryidname                                        /*tek_industryidname*/
    ,P1.estimatedclosedate                                        /*estimatedclosedate*/
    ,P1.tek_taglist                                               /*tek_taglist*/
    ,P1.discountamount                                            /*discountamount*/
    ,P1.tek_terr_areaidname                                       /*tek_terr_areaidname*/
    ,P1.tek_terr_branchidname                                     /*tek_terr_branchidname*/
    ,P1.tek_extension                                             /*tek_extension*/
    ,P1.tek_companynamelegal                                      /*tek_companynamelegal*/
    ,P1.accountnumber                                             /*accountnumber*/
    ,P1.tek_marketing_program_type_idname                         /*tek_marketing_program_type_idname*/
    ,P1.tek_leadnumber                                            /*tek_leadnumber*/
    ,P1.tek_contactnumber                                         /*tek_contactnumber*/
    ,P1.parentaccountidname                                       /*parentaccountidname*/
    ,P1.Scd_Start_Dt                                              /*开始时间*/
    ,P1.Scd_End_Dt                                                /*结束时间*/
    ,P1.Etl_Batch_No                                              /*作业批次号*/
    ,P1.Etl_First_Dt                                              /*最初入库时间*/
    ,P1.Etl_Job                                                   /*作业名称*/
    ,P1.Etl_Proc_Dt                                               /*本次入库时间*/
    ,P1.Etl_Tx_Dt                                                 /*作业运行时间*/
    ,P1.Src_Sysname                                               /*来源系统*/
    ,P1.Src_Table                                                 /*来源表*/
    ,P1.parentcontactidname                                       /*parentcontactidname*/
    ,P1.tek_productidname                                         /*tek_productidname*/
    ,P1.tek_productfamilyidname                                   /*tek_productfamilyidname*/
    ,P1.transactioncurrencyidname                                 /*transactioncurrencyidname*/
    
FROM    :PDMDB.t01_crm_opportunity P1
WHERE    P1.Scd_End_Dt   = TO_DATE(:MAXDATE,'YYYYMMDD')
    AND P1.ETL_Job  = :ETLJOB
    ;
/*"今日数据"与"当前有效数据"进行比较找出新增及更新的数据，比对条件是：除去开始日期和结束日期的所有 */
/*字段。                                                                                           */
INSERT INTO t01_crm_opportunity_agi_INS(
     tek_opportunitynumber                                     /*tek_opportunitynumber*/
     , tek_unitpricetotal_base                                   /*tek_unitpricetotal_base*/
     , tek_totaldiscountpercent                                  /*tek_totaldiscountpercent*/
     , totaldiscountamount_base                                  /*totaldiscountamount_base*/
     , estimatedvalue_base                                       /*estimatedvalue_base*/
     , totalamount                                               /*totalamount*/
     , tek_salesfunnelstagename                                  /*tek_salesfunnelstagename*/
     , tek_funnelstagenumber                                     /*tek_funnelstagenumber*/
     , statuscodename                                            /*statuscodename*/
     , statecodename                                             /*statecodename*/
     , tek_regionidname                                          /*tek_regionidname*/
     , name                                                      /*name*/
     , tek_accountmanageridname                                  /*tek_accountmanageridname*/
     , tek_oppterritoryidname                                    /*tek_oppterritoryidname*/
     , tek_opp_includeinforecastname                             /*tek_opp_includeinforecastname*/
     , tek_isriskname                                            /*tek_isriskname*/
     , tek_opportunityage                                        /*tek_opportunityage*/
     , createdon                                                 /*createdon*/
     , createdbyname                                             /*createdbyname*/
     , tek_piplinelastupdatedon                                  /*tek_piplinelastupdatedon*/
     , tek_laststatusdate                                        /*tek_laststatusdate*/
     , tek_channelidname                                         /*tek_channelidname*/
     , tek_tektronixapname                                       /*tek_tektronixapname*/
     , tek_purchasemethodname                                    /*tek_purchasemethodname*/
     , campaignidname                                            /*campaignidname*/
     , tek_webvisitormedium                                      /*tek_webvisitormedium*/
     , tek_webvisitorsource                                      /*tek_webvisitorsource*/
     , tek_customerapplication                                   /*tek_customerapplication*/
     , tek_vertical_segmentname                                  /*tek_vertical_segmentname*/
     , tek_competitivestatusname                                 /*tek_competitivestatusname*/
     , tek_importantopportunityname                              /*tek_importantopportunityname*/
     , tek_applicationidname                                     /*tek_applicationidname*/
     , tek_industryidname                                        /*tek_industryidname*/
     , estimatedclosedate                                        /*estimatedclosedate*/
     , tek_taglist                                               /*tek_taglist*/
     , discountamount                                            /*discountamount*/
     , tek_terr_areaidname                                       /*tek_terr_areaidname*/
     , tek_terr_branchidname                                     /*tek_terr_branchidname*/
     , tek_extension                                             /*tek_extension*/
     , tek_companynamelegal                                      /*tek_companynamelegal*/
     , accountnumber                                             /*accountnumber*/
     , tek_marketing_program_type_idname                         /*tek_marketing_program_type_idname*/
     , tek_leadnumber                                            /*tek_leadnumber*/
     , tek_contactnumber                                         /*tek_contactnumber*/
     , parentaccountidname                                       /*parentaccountidname*/
     , Scd_Start_Dt                                              /*开始时间*/
     , Scd_End_Dt                                                /*结束时间*/
     , Etl_Batch_No                                              /*作业批次号*/
     , Etl_First_Dt                                              /*最初入库时间*/
     , Etl_Job                                                   /*作业名称*/
     , Etl_Proc_Dt                                               /*本次入库时间*/
     , Etl_Tx_Dt                                                 /*作业运行时间*/
     , Src_Sysname                                               /*来源系统*/
     , Src_Table                                                 /*来源表*/
     , parentcontactidname                                       /*parentcontactidname*/
     , tek_productidname                                         /*tek_productidname*/
     , tek_productfamilyidname                                   /*tek_productfamilyidname*/
     , transactioncurrencyidname                                 /*transactioncurrencyidname*/
    )
SELECT      
     P1.tek_opportunitynumber                                     /*tek_opportunitynumber*/
     , P1.tek_unitpricetotal_base                                   /*tek_unitpricetotal_base*/
     , P1.tek_totaldiscountpercent                                  /*tek_totaldiscountpercent*/
     , P1.totaldiscountamount_base                                  /*totaldiscountamount_base*/
     , P1.estimatedvalue_base                                       /*estimatedvalue_base*/
     , P1.totalamount                                               /*totalamount*/
     , P1.tek_salesfunnelstagename                                  /*tek_salesfunnelstagename*/
     , P1.tek_funnelstagenumber                                     /*tek_funnelstagenumber*/
     , P1.statuscodename                                            /*statuscodename*/
     , P1.statecodename                                             /*statecodename*/
     , P1.tek_regionidname                                          /*tek_regionidname*/
     , P1.name                                                      /*name*/
     , P1.tek_accountmanageridname                                  /*tek_accountmanageridname*/
     , P1.tek_oppterritoryidname                                    /*tek_oppterritoryidname*/
     , P1.tek_opp_includeinforecastname                             /*tek_opp_includeinforecastname*/
     , P1.tek_isriskname                                            /*tek_isriskname*/
     , P1.tek_opportunityage                                        /*tek_opportunityage*/
     , P1.createdon                                                 /*createdon*/
     , P1.createdbyname                                             /*createdbyname*/
     , P1.tek_piplinelastupdatedon                                  /*tek_piplinelastupdatedon*/
     , P1.tek_laststatusdate                                        /*tek_laststatusdate*/
     , P1.tek_channelidname                                         /*tek_channelidname*/
     , P1.tek_tektronixapname                                       /*tek_tektronixapname*/
     , P1.tek_purchasemethodname                                    /*tek_purchasemethodname*/
     , P1.campaignidname                                            /*campaignidname*/
     , P1.tek_webvisitormedium                                      /*tek_webvisitormedium*/
     , P1.tek_webvisitorsource                                      /*tek_webvisitorsource*/
     , P1.tek_customerapplication                                   /*tek_customerapplication*/
     , P1.tek_vertical_segmentname                                  /*tek_vertical_segmentname*/
     , P1.tek_competitivestatusname                                 /*tek_competitivestatusname*/
     , P1.tek_importantopportunityname                              /*tek_importantopportunityname*/
     , P1.tek_applicationidname                                     /*tek_applicationidname*/
     , P1.tek_industryidname                                        /*tek_industryidname*/
     , P1.estimatedclosedate                                        /*estimatedclosedate*/
     , P1.tek_taglist                                               /*tek_taglist*/
     , P1.discountamount                                            /*discountamount*/
     , P1.tek_terr_areaidname                                       /*tek_terr_areaidname*/
     , P1.tek_terr_branchidname                                     /*tek_terr_branchidname*/
     , P1.tek_extension                                             /*tek_extension*/
     , P1.tek_companynamelegal                                      /*tek_companynamelegal*/
     , P1.accountnumber                                             /*accountnumber*/
     , P1.tek_marketing_program_type_idname                         /*tek_marketing_program_type_idname*/
     , P1.tek_leadnumber                                            /*tek_leadnumber*/
     , P1.tek_contactnumber                                         /*tek_contactnumber*/
     , P1.parentaccountidname                                       /*parentaccountidname*/
     , P1.Scd_Start_Dt                                              /*开始时间*/
     , P1.Scd_End_Dt                                                /*结束时间*/
     , P1.Etl_Batch_No                                              /*作业批次号*/
     , P1.Etl_First_Dt                                              /*最初入库时间*/
     , P1.Etl_Job                                                   /*作业名称*/
     , P1.Etl_Proc_Dt                                               /*本次入库时间*/
     , P1.Etl_Tx_Dt                                                 /*作业运行时间*/
     , P1.Src_Sysname                                               /*来源系统*/
     , P1.Src_Table                                                 /*来源表*/
     , P1.parentcontactidname                                       /*parentcontactidname*/
     , P1.tek_productidname                                         /*tek_productidname*/
     , P1.tek_productfamilyidname                                   /*tek_productfamilyidname*/
     , P1.transactioncurrencyidname                                 /*transactioncurrencyidname*/
    
FROM    t01_crm_opportunity_agi_CUR_I P1
LEFT JOIN t01_crm_opportunity_agi_CUR P2
    ON   P1.tek_opportunitynumber = P2.tek_opportunitynumber                             
     AND P1.Scd_Start_Dt = P2.Scd_Start_Dt                                      
     AND P1.name = P2.name                                              
     AND P1.tek_tektronixapname = P2.tek_tektronixapname                               
     AND P1.estimatedclosedate = P2.estimatedclosedate                                
     AND P1.parentaccountidname = P2.parentaccountidname                               
     AND P1.parentcontactidname = P2.parentcontactidname                               
     AND P1.tek_productidname = P2.tek_productidname                                 
     AND P1.tek_productfamilyidname = P2.tek_productfamilyidname                           
     AND P1.transactioncurrencyidname = P2.transactioncurrencyidname                         
     AND P1.tek_unitpricetotal_base = P2.tek_unitpricetotal_base                           
     AND P1.tek_totaldiscountpercent = P2.tek_totaldiscountpercent                          
     AND P1.totaldiscountamount_base = P2.totaldiscountamount_base                          
     AND P1.estimatedvalue_base = P2.estimatedvalue_base                               
     AND P1.totalamount = P2.totalamount                                       
     AND P1.tek_salesfunnelstagename = P2.tek_salesfunnelstagename                          
     AND P1.tek_funnelstagenumber = P2.tek_funnelstagenumber                             
     AND P1.statuscodename = P2.statuscodename                                    
     AND P1.statecodename = P2.statecodename                                     
     AND P1.tek_regionidname = P2.tek_regionidname                                  
     AND P1.tek_accountmanageridname = P2.tek_accountmanageridname                          
     AND P1.tek_oppterritoryidname = P2.tek_oppterritoryidname                            
     AND P1.tek_opp_includeinforecastname = P2.tek_opp_includeinforecastname                     
     AND P1.tek_isriskname = P2.tek_isriskname                                    
     AND P1.tek_opportunityage = P2.tek_opportunityage                                
     AND P1.createdon = P2.createdon                                         
     AND P1.createdbyname = P2.createdbyname                                     
     AND P1.tek_piplinelastupdatedon = P2.tek_piplinelastupdatedon                          
     AND P1.tek_laststatusdate = P2.tek_laststatusdate                                
     AND P1.tek_channelidname = P2.tek_channelidname                                 
     AND P1.tek_purchasemethodname = P2.tek_purchasemethodname                            
     AND P1.campaignidname = P2.campaignidname                                    
     AND P1.tek_webvisitormedium = P2.tek_webvisitormedium                              
     AND P1.tek_webvisitorsource = P2.tek_webvisitorsource                              
     AND P1.tek_customerapplication = P2.tek_customerapplication                           
     AND P1.tek_vertical_segmentname = P2.tek_vertical_segmentname                          
     AND P1.tek_competitivestatusname = P2.tek_competitivestatusname                         
     AND P1.tek_importantopportunityname = P2.tek_importantopportunityname                      
     AND P1.tek_applicationidname = P2.tek_applicationidname                             
     AND P1.tek_industryidname = P2.tek_industryidname                                
     AND P1.tek_taglist = P2.tek_taglist                                       
     AND P1.discountamount = P2.discountamount                                    
     AND P1.tek_terr_areaidname = P2.tek_terr_areaidname                               
     AND P1.tek_terr_branchidname = P2.tek_terr_branchidname                             
     AND P1.tek_extension = P2.tek_extension                                     
     AND P1.tek_companynamelegal = P2.tek_companynamelegal                              
     AND P1.accountnumber = P2.accountnumber                                     
     AND P1.tek_marketing_program_type_idname = P2.tek_marketing_program_type_idname                 
     AND P1.tek_leadnumber = P2.tek_leadnumber                                    
     AND P1.tek_contactnumber = P2.tek_contactnumber                                 
     AND P2.ETL_Job =:ETLJOB
WHERE           
         P2.tek_opportunitynumber IS NULL
     AND P2.Scd_Start_Dt IS NULL
     AND P2.name IS NULL
     AND P2.tek_tektronixapname IS NULL
     AND P2.estimatedclosedate IS NULL
     AND P2.parentaccountidname IS NULL
     AND P2.parentcontactidname IS NULL
     AND P2.tek_productidname IS NULL
     AND P2.tek_productfamilyidname IS NULL
     AND P2.transactioncurrencyidname IS NULL
     AND P2.tek_unitpricetotal_base IS NULL
     AND P2.tek_totaldiscountpercent IS NULL
     AND P2.totaldiscountamount_base IS NULL
     AND P2.estimatedvalue_base IS NULL
     AND P2.totalamount IS NULL
     AND P2.tek_salesfunnelstagename IS NULL
     AND P2.tek_funnelstagenumber IS NULL
     AND P2.statuscodename IS NULL
     AND P2.statecodename IS NULL
     AND P2.tek_regionidname IS NULL
     AND P2.tek_accountmanageridname IS NULL
     AND P2.tek_oppterritoryidname IS NULL
     AND P2.tek_opp_includeinforecastname IS NULL
     AND P2.tek_isriskname IS NULL
     AND P2.tek_opportunityage IS NULL
     AND P2.createdon IS NULL
     AND P2.createdbyname IS NULL
     AND P2.tek_piplinelastupdatedon IS NULL
     AND P2.tek_laststatusdate IS NULL
     AND P2.tek_channelidname IS NULL
     AND P2.tek_purchasemethodname IS NULL
     AND P2.campaignidname IS NULL
     AND P2.tek_webvisitormedium IS NULL
     AND P2.tek_webvisitorsource IS NULL
     AND P2.tek_customerapplication IS NULL
     AND P2.tek_vertical_segmentname IS NULL
     AND P2.tek_competitivestatusname IS NULL
     AND P2.tek_importantopportunityname IS NULL
     AND P2.tek_applicationidname IS NULL
     AND P2.tek_industryidname IS NULL
     AND P2.tek_taglist IS NULL
     AND P2.discountamount IS NULL
     AND P2.tek_terr_areaidname IS NULL
     AND P2.tek_terr_branchidname IS NULL
     AND P2.tek_extension IS NULL
     AND P2.tek_companynamelegal IS NULL
     AND P2.accountnumber IS NULL
     AND P2.tek_marketing_program_type_idname IS NULL
     AND P2.tek_leadnumber IS NULL
     AND P2.tek_contactnumber IS NULL
    
;


INSERT INTO t01_crm_opportunity_agi_CUR_D (
            tek_opportunitynumber                                     /*tek_opportunitynumber*/
            , tek_unitpricetotal_base                                   /*tek_unitpricetotal_base*/
            , tek_totaldiscountpercent                                  /*tek_totaldiscountpercent*/
            , totaldiscountamount_base                                  /*totaldiscountamount_base*/
            , estimatedvalue_base                                       /*estimatedvalue_base*/
            , totalamount                                               /*totalamount*/
            , tek_salesfunnelstagename                                  /*tek_salesfunnelstagename*/
            , tek_funnelstagenumber                                     /*tek_funnelstagenumber*/
            , statuscodename                                            /*statuscodename*/
            , statecodename                                             /*statecodename*/
            , tek_regionidname                                          /*tek_regionidname*/
            , name                                                      /*name*/
            , tek_accountmanageridname                                  /*tek_accountmanageridname*/
            , tek_oppterritoryidname                                    /*tek_oppterritoryidname*/
            , tek_opp_includeinforecastname                             /*tek_opp_includeinforecastname*/
            , tek_isriskname                                            /*tek_isriskname*/
            , tek_opportunityage                                        /*tek_opportunityage*/
            , createdon                                                 /*createdon*/
            , createdbyname                                             /*createdbyname*/
            , tek_piplinelastupdatedon                                  /*tek_piplinelastupdatedon*/
            , tek_laststatusdate                                        /*tek_laststatusdate*/
            , tek_channelidname                                         /*tek_channelidname*/
            , tek_tektronixapname                                       /*tek_tektronixapname*/
            , tek_purchasemethodname                                    /*tek_purchasemethodname*/
            , campaignidname                                            /*campaignidname*/
            , tek_webvisitormedium                                      /*tek_webvisitormedium*/
            , tek_webvisitorsource                                      /*tek_webvisitorsource*/
            , tek_customerapplication                                   /*tek_customerapplication*/
            , tek_vertical_segmentname                                  /*tek_vertical_segmentname*/
            , tek_competitivestatusname                                 /*tek_competitivestatusname*/
            , tek_importantopportunityname                              /*tek_importantopportunityname*/
            , tek_applicationidname                                     /*tek_applicationidname*/
            , tek_industryidname                                        /*tek_industryidname*/
            , estimatedclosedate                                        /*estimatedclosedate*/
            , tek_taglist                                               /*tek_taglist*/
            , discountamount                                            /*discountamount*/
            , tek_terr_areaidname                                       /*tek_terr_areaidname*/
            , tek_terr_branchidname                                     /*tek_terr_branchidname*/
            , tek_extension                                             /*tek_extension*/
            , tek_companynamelegal                                      /*tek_companynamelegal*/
            , accountnumber                                             /*accountnumber*/
            , tek_marketing_program_type_idname                         /*tek_marketing_program_type_idname*/
            , tek_leadnumber                                            /*tek_leadnumber*/
            , tek_contactnumber                                         /*tek_contactnumber*/
            , parentaccountidname                                       /*parentaccountidname*/
            , Scd_Start_Dt                                              /*开始时间*/
            , Scd_End_Dt                                                /*结束时间*/
            , Etl_Batch_No                                              /*作业批次号*/
            , Etl_First_Dt                                              /*最初入库时间*/
            , Etl_Job                                                   /*作业名称*/
            , Etl_Proc_Dt                                               /*本次入库时间*/
            , Etl_Tx_Dt                                                 /*作业运行时间*/
            , Src_Sysname                                               /*来源系统*/
            , Src_Table                                                 /*来源表*/
            , parentcontactidname                                       /*parentcontactidname*/
            , tek_productidname                                         /*tek_productidname*/
            , tek_productfamilyidname                                   /*tek_productfamilyidname*/
            , transactioncurrencyidname                                 /*transactioncurrencyidname*/
           )
SELECT      
            P1.tek_opportunitynumber                                     /*tek_opportunitynumber*/
            , P1.tek_unitpricetotal_base                                   /*tek_unitpricetotal_base*/
            , P1.tek_totaldiscountpercent                                  /*tek_totaldiscountpercent*/
            , P1.totaldiscountamount_base                                  /*totaldiscountamount_base*/
            , P1.estimatedvalue_base                                       /*estimatedvalue_base*/
            , P1.totalamount                                               /*totalamount*/
            , P1.tek_salesfunnelstagename                                  /*tek_salesfunnelstagename*/
            , P1.tek_funnelstagenumber                                     /*tek_funnelstagenumber*/
            , P1.statuscodename                                            /*statuscodename*/
            , P1.statecodename                                             /*statecodename*/
            , P1.tek_regionidname                                          /*tek_regionidname*/
            , P1.name                                                      /*name*/
            , P1.tek_accountmanageridname                                  /*tek_accountmanageridname*/
            , P1.tek_oppterritoryidname                                    /*tek_oppterritoryidname*/
            , P1.tek_opp_includeinforecastname                             /*tek_opp_includeinforecastname*/
            , P1.tek_isriskname                                            /*tek_isriskname*/
            , P1.tek_opportunityage                                        /*tek_opportunityage*/
            , P1.createdon                                                 /*createdon*/
            , P1.createdbyname                                             /*createdbyname*/
            , P1.tek_piplinelastupdatedon                                  /*tek_piplinelastupdatedon*/
            , P1.tek_laststatusdate                                        /*tek_laststatusdate*/
            , P1.tek_channelidname                                         /*tek_channelidname*/
            , P1.tek_tektronixapname                                       /*tek_tektronixapname*/
            , P1.tek_purchasemethodname                                    /*tek_purchasemethodname*/
            , P1.campaignidname                                            /*campaignidname*/
            , P1.tek_webvisitormedium                                      /*tek_webvisitormedium*/
            , P1.tek_webvisitorsource                                      /*tek_webvisitorsource*/
            , P1.tek_customerapplication                                   /*tek_customerapplication*/
            , P1.tek_vertical_segmentname                                  /*tek_vertical_segmentname*/
            , P1.tek_competitivestatusname                                 /*tek_competitivestatusname*/
            , P1.tek_importantopportunityname                              /*tek_importantopportunityname*/
            , P1.tek_applicationidname                                     /*tek_applicationidname*/
            , P1.tek_industryidname                                        /*tek_industryidname*/
            , P1.estimatedclosedate                                        /*estimatedclosedate*/
            , P1.tek_taglist                                               /*tek_taglist*/
            , P1.discountamount                                            /*discountamount*/
            , P1.tek_terr_areaidname                                       /*tek_terr_areaidname*/
            , P1.tek_terr_branchidname                                     /*tek_terr_branchidname*/
            , P1.tek_extension                                             /*tek_extension*/
            , P1.tek_companynamelegal                                      /*tek_companynamelegal*/
            , P1.accountnumber                                             /*accountnumber*/
            , P1.tek_marketing_program_type_idname                         /*tek_marketing_program_type_idname*/
            , P1.tek_leadnumber                                            /*tek_leadnumber*/
            , P1.tek_contactnumber                                         /*tek_contactnumber*/
            , P1.parentaccountidname                                       /*parentaccountidname*/
            , P1.Scd_Start_Dt                                              /*开始时间*/
            , P1.Scd_End_Dt                                                /*结束时间*/
            , P1.Etl_Batch_No                                              /*作业批次号*/
            , P1.Etl_First_Dt                                              /*最初入库时间*/
            , P1.Etl_Job                                                   /*作业名称*/
            , P1.Etl_Proc_Dt                                               /*本次入库时间*/
            , P1.Etl_Tx_Dt                                                 /*作业运行时间*/
            , P1.Src_Sysname                                               /*来源系统*/
            , P1.Src_Table                                                 /*来源表*/
            , P1.parentcontactidname                                       /*parentcontactidname*/
            , P1.tek_productidname                                         /*tek_productidname*/
            , P1.tek_productfamilyidname                                   /*tek_productfamilyidname*/
            , P1.transactioncurrencyidname                                 /*transactioncurrencyidname*/
           
FROM    t01_crm_opportunity_agi_CUR_I P1
LEFT JOIN t01_crm_opportunity_agi_CUR P2
ON   P1.tek_opportunitynumber = P2.tek_opportunitynumber                             
AND P1.Scd_Start_Dt = P2.Scd_Start_Dt                                      
WHERE  P2.tek_opportunitynumber IS NULL
 AND P2.Scd_Start_Dt IS NULL
AND P2.Scd_End_Dt   = TO_DATE(:MAXDATE,'YYYYMMDD')
AND P2.ETL_Job  = :ETLJOB
;


/*更新目标表中数据,对更新的数据进行封口,即置结束日期为TX_DATE                                      */
UPDATE :PDMDB.t01_crm_opportunity
   SET  Scd_End_Dt   = TO_DATE(:TXDATE,'YYYYMMDD')
        ,Etl_Tx_Dt=:TXDATE
        ,Etl_Proc_Dt=CURRENT_TIMESTAMP(0)
WHERE Scd_End_Dt   = TO_DATE(:MAXDATE, 'YYYYMMDD')
    AND  (:PDMDB.t01_crm_opportunity.ETL_Job = :ETLJOB)
    AND ( tek_opportunitynumber , Scd_Start_Dt)
IN  (SELECT  tek_opportunitynumber                              , Scd_Start_Dt                                      
    FROM t01_crm_opportunity_agi_INS) 
                
/*根据比对条件将目标表中删除数据进行相应的处理                                                     */
;UPDATE    :PDMDB.t01_crm_opportunity
   SET    Scd_End_Dt= TO_DATE(:TXDATE, 'YYYYMMDD')
          ,Etl_Tx_Dt=:TXDATE
         ,ETL_Proc_Dt=CURRENT_TIMESTAMP(0)
 WHERE   Scd_End_Dt=TO_DATE(:MAXDATE,'YYYYMMDD')
   AND  (:PDMDB.t01_crm_opportunity.ETL_Job = :ETLJOB)
   AND  ( tek_opportunitynumber , Scd_Start_Dt)
IN  (SELECT 
     tek_opportunitynumber                              , Scd_Start_Dt                                      
FROM t01_crm_opportunity_agi_CUR_D)
/*然后将新增的数据插入到目标表中，置开始日期为TX_DATE，结束日期置为MAXDATE                         */
;INSERT INTO :PDMDB.t01_crm_opportunity (
           tek_opportunitynumber                                     /*tek_opportunitynumber*/
          ,tek_unitpricetotal_base                                   /*tek_unitpricetotal_base*/
          ,tek_totaldiscountpercent                                  /*tek_totaldiscountpercent*/
          ,totaldiscountamount_base                                  /*totaldiscountamount_base*/
          ,estimatedvalue_base                                       /*estimatedvalue_base*/
          ,totalamount                                               /*totalamount*/
          ,tek_salesfunnelstagename                                  /*tek_salesfunnelstagename*/
          ,tek_funnelstagenumber                                     /*tek_funnelstagenumber*/
          ,statuscodename                                            /*statuscodename*/
          ,statecodename                                             /*statecodename*/
          ,tek_regionidname                                          /*tek_regionidname*/
          ,name                                                      /*name*/
          ,tek_accountmanageridname                                  /*tek_accountmanageridname*/
          ,tek_oppterritoryidname                                    /*tek_oppterritoryidname*/
          ,tek_opp_includeinforecastname                             /*tek_opp_includeinforecastname*/
          ,tek_isriskname                                            /*tek_isriskname*/
          ,tek_opportunityage                                        /*tek_opportunityage*/
          ,createdon                                                 /*createdon*/
          ,createdbyname                                             /*createdbyname*/
          ,tek_piplinelastupdatedon                                  /*tek_piplinelastupdatedon*/
          ,tek_laststatusdate                                        /*tek_laststatusdate*/
          ,tek_channelidname                                         /*tek_channelidname*/
          ,tek_tektronixapname                                       /*tek_tektronixapname*/
          ,tek_purchasemethodname                                    /*tek_purchasemethodname*/
          ,campaignidname                                            /*campaignidname*/
          ,tek_webvisitormedium                                      /*tek_webvisitormedium*/
          ,tek_webvisitorsource                                      /*tek_webvisitorsource*/
          ,tek_customerapplication                                   /*tek_customerapplication*/
          ,tek_vertical_segmentname                                  /*tek_vertical_segmentname*/
          ,tek_competitivestatusname                                 /*tek_competitivestatusname*/
          ,tek_importantopportunityname                              /*tek_importantopportunityname*/
          ,tek_applicationidname                                     /*tek_applicationidname*/
          ,tek_industryidname                                        /*tek_industryidname*/
          ,estimatedclosedate                                        /*estimatedclosedate*/
          ,tek_taglist                                               /*tek_taglist*/
          ,discountamount                                            /*discountamount*/
          ,tek_terr_areaidname                                       /*tek_terr_areaidname*/
          ,tek_terr_branchidname                                     /*tek_terr_branchidname*/
          ,tek_extension                                             /*tek_extension*/
          ,tek_companynamelegal                                      /*tek_companynamelegal*/
          ,accountnumber                                             /*accountnumber*/
          ,tek_marketing_program_type_idname                         /*tek_marketing_program_type_idname*/
          ,tek_leadnumber                                            /*tek_leadnumber*/
          ,tek_contactnumber                                         /*tek_contactnumber*/
          ,parentaccountidname                                       /*parentaccountidname*/
          ,Scd_Start_Dt                                              /*开始时间*/
          ,Scd_End_Dt                                                /*结束时间*/
          ,Etl_Batch_No                                              /*作业批次号*/
          ,Etl_First_Dt                                              /*最初入库时间*/
          ,Etl_Job                                                   /*作业名称*/
          ,Etl_Proc_Dt                                               /*本次入库时间*/
          ,Etl_Tx_Dt                                                 /*作业运行时间*/
          ,Src_Sysname                                               /*来源系统*/
          ,Src_Table                                                 /*来源表*/
          ,parentcontactidname                                       /*parentcontactidname*/
          ,tek_productidname                                         /*tek_productidname*/
          ,tek_productfamilyidname                                   /*tek_productfamilyidname*/
          ,transactioncurrencyidname                                 /*transactioncurrencyidname*/
 )
SELECT
          P1.tek_opportunitynumber                                     /*tek_opportunitynumber*/
         ,P1.tek_unitpricetotal_base                                   /*tek_unitpricetotal_base*/
         ,P1.tek_totaldiscountpercent                                  /*tek_totaldiscountpercent*/
         ,P1.totaldiscountamount_base                                  /*totaldiscountamount_base*/
         ,P1.estimatedvalue_base                                       /*estimatedvalue_base*/
         ,P1.totalamount                                               /*totalamount*/
         ,P1.tek_salesfunnelstagename                                  /*tek_salesfunnelstagename*/
         ,P1.tek_funnelstagenumber                                     /*tek_funnelstagenumber*/
         ,P1.statuscodename                                            /*statuscodename*/
         ,P1.statecodename                                             /*statecodename*/
         ,P1.tek_regionidname                                          /*tek_regionidname*/
         ,P1.name                                                      /*name*/
         ,P1.tek_accountmanageridname                                  /*tek_accountmanageridname*/
         ,P1.tek_oppterritoryidname                                    /*tek_oppterritoryidname*/
         ,P1.tek_opp_includeinforecastname                             /*tek_opp_includeinforecastname*/
         ,P1.tek_isriskname                                            /*tek_isriskname*/
         ,P1.tek_opportunityage                                        /*tek_opportunityage*/
         ,P1.createdon                                                 /*createdon*/
         ,P1.createdbyname                                             /*createdbyname*/
         ,P1.tek_piplinelastupdatedon                                  /*tek_piplinelastupdatedon*/
         ,P1.tek_laststatusdate                                        /*tek_laststatusdate*/
         ,P1.tek_channelidname                                         /*tek_channelidname*/
         ,P1.tek_tektronixapname                                       /*tek_tektronixapname*/
         ,P1.tek_purchasemethodname                                    /*tek_purchasemethodname*/
         ,P1.campaignidname                                            /*campaignidname*/
         ,P1.tek_webvisitormedium                                      /*tek_webvisitormedium*/
         ,P1.tek_webvisitorsource                                      /*tek_webvisitorsource*/
         ,P1.tek_customerapplication                                   /*tek_customerapplication*/
         ,P1.tek_vertical_segmentname                                  /*tek_vertical_segmentname*/
         ,P1.tek_competitivestatusname                                 /*tek_competitivestatusname*/
         ,P1.tek_importantopportunityname                              /*tek_importantopportunityname*/
         ,P1.tek_applicationidname                                     /*tek_applicationidname*/
         ,P1.tek_industryidname                                        /*tek_industryidname*/
         ,P1.estimatedclosedate                                        /*estimatedclosedate*/
         ,P1.tek_taglist                                               /*tek_taglist*/
         ,P1.discountamount                                            /*discountamount*/
         ,P1.tek_terr_areaidname                                       /*tek_terr_areaidname*/
         ,P1.tek_terr_branchidname                                     /*tek_terr_branchidname*/
         ,P1.tek_extension                                             /*tek_extension*/
         ,P1.tek_companynamelegal                                      /*tek_companynamelegal*/
         ,P1.accountnumber                                             /*accountnumber*/
         ,P1.tek_marketing_program_type_idname                         /*tek_marketing_program_type_idname*/
         ,P1.tek_leadnumber                                            /*tek_leadnumber*/
         ,P1.tek_contactnumber                                         /*tek_contactnumber*/
         ,P1.parentaccountidname                                       /*parentaccountidname*/
         ,P1.Scd_Start_Dt                                              /*开始时间*/
         ,P1.Scd_End_Dt                                                /*结束时间*/
         ,P1.Etl_Batch_No                                              /*作业批次号*/
         ,P1.Etl_First_Dt                                              /*最初入库时间*/
         ,P1.Etl_Job                                                   /*作业名称*/
         ,P1.Etl_Proc_Dt                                               /*本次入库时间*/
         ,P1.Etl_Tx_Dt                                                 /*作业运行时间*/
         ,P1.Src_Sysname                                               /*来源系统*/
         ,P1.Src_Table                                                 /*来源表*/
         ,P1.parentcontactidname                                       /*parentcontactidname*/
         ,P1.tek_productidname                                         /*tek_productidname*/
         ,P1.tek_productfamilyidname                                   /*tek_productfamilyidname*/
         ,P1.transactioncurrencyidname                                 /*transactioncurrencyidname*/

FROM  t01_crm_opportunity_agi_INS P1
;


;

;
/*****程序结束退出                                               */
\q

